---
title: WindowOrWorkerGlobalScope.setTimeout()
slug: Web/API/WindowOrWorkerGlobalScope/setTimeout
tags:
  - API
  - HTML DOM
  - Intervals
  - JavaScript timers
  - MakeBrowserAgnostic
  - Method
  - NeedsMarkupWork
  - NeedsUpdate
  - Reference
  - Timers
  - WindowOrWorkerGlobalScope
  - setTimeout
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <strong><code>setTimeout()</code></strong> method of the {{domxref("WindowOrWorkerGlobalScope")}} mixin (and successor to <code>Window.setTimeout()</code>) sets a timer which executes a function or specified piece of code once the timer expires.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>timeoutID</var> = <var>scope</var>.setTimeout(<var>function</var>[, <var>delay</var>, <var>arg1</var>, <var>arg2</var>, ...]);
var <var>timeoutID</var> = <var>scope</var>.setTimeout(<var>function</var>[, <var>delay</var>]);
var <var>timeoutID</var> = <var>scope</var>.setTimeout(<var>code</var>[, <var>delay</var>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>function</var></code></dt>
 <dd>A {{jsxref("function")}} to be executed after the timer expires.</dd>
 <dt><code><var>code</var></code></dt>
 <dd>An alternative syntax that allows you to include a string instead of a function, which is compiled and executed when the timer expires. This syntax is <strong>not recommended</strong> for the same reasons that make using {{jsxref("Global_Objects/eval", "eval()")}} a security risk.</dd>
 <dt><code><var>delay</var></code> {{optional_inline}}</dt>
 <dd>The time, in milliseconds (thousandths of a second), the timer should wait before the specified function or code is executed. If this parameter is omitted, a value of 0 is used, meaning execute "immediately", or more accurately, the next event cycle. Note that in either case, the actual delay may be longer than intended; see {{anch("Reasons for delays longer than specified")}} below.</dd>
 <dt><code><var>arg1</var>, ..., <var>argN</var></code> {{optional_inline}}</dt>
 <dd>Additional arguments which are passed through to the function specified by <code><var>function</var></code>.</dd>
</dl>

<div class="note">
<p><strong>Note</strong>: Passing additional parameters to the function in the first syntax does not work in Internet Explorer 9 and below. If you want to enable this functionality on that browser, you must use a polyfill (see the {{anch("Polyfill")}} section).</p>
</div>

<h3 id="Return_value">Return value</h3>

<p>The returned <code><var>timeoutID</var></code> is a positive integer value which identifies the timer created by the call to <code>setTimeout()</code>; this value can be passed to {{domxref("WindowOrWorkerGlobalScope.clearTimeout","clearTimeout()")}} to cancel the timeout.</p>

<p>It may be helpful to be aware that <code>setTimeout()</code> and {{domxref("WindowOrWorkerGlobalScope.setInterval", "setInterval()")}} share the same pool of IDs, and that <code>clearTimeout()</code> and {{domxref("WindowOrWorkerGlobalScope.clearInterval", "clearInterval()")}} can technically be used interchangeably. For clarity, however, you should try to always match them to avoid confusion when maintaining your code.</p>

<p>It is guaranteed that a timeout ID will never be reused by a subsequent call to <code>setTimeout()</code> or <code>setInterval()</code> on the same object (a window or a worker). However, different objects use separate pools of IDs.</p>

<h2 id="Example">Example</h2>

<p>The following example sets up two simple buttons in a web page and hooks them to the <code>setTimeout()</code> and <code>clearTimeout()</code> routines. Pressing the first button will set a timeout which calls an alert dialog after two seconds and stores the timeout id for use by <code>clearTimeout()</code>. You may optionally cancel this timeout by pressing on the second button.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;Live Example&lt;/p&gt;
&lt;button onclick="delayedAlert();"&gt;Show an alert box after two seconds&lt;/button&gt;
&lt;p&gt;&lt;/p&gt;
&lt;button onclick="clearAlert();"&gt;Cancel alert before it happens&lt;/button&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">var timeoutID;

function delayedAlert() {
  timeoutID = window.setTimeout(window.alert, 2*1000, 'That was really slow!');
}

function clearAlert() {
  window.clearTimeout(timeoutID);
}
</pre>

<h3 id="Result">Result</h3>

<p>{{EmbedLiveSample('Example')}}</p>

<p>See also <a href="/en-US/docs/Web/API/WindowTimers/clearTimeout#Example"><code>clearTimeout()</code> example</a>.</p>

<h2 id="Polyfill">Polyfill</h2>

<p>If you need to pass one or more arguments to your callback function, but need it to work in browsers which don't support sending additional arguments using either <code>setTimeout()</code> or <code>setInterval()</code> (e.g., Internet Explorer 9 and below), you can include this polyfill to enable the HTML5 standard arguments-passing functionality. Just add this code to the top of your script:</p>

<pre class="brush: js notranslate">/*\
|*|
|*|  Polyfill which enables the passage of arbitrary arguments to the
|*|  callback functions of JavaScript timers (HTML5 standard syntax).
|*|
|*|  https://developer.mozilla.org/en-US/docs/DOM/window.setInterval
|*|
|*|  Syntax:
|*|  var timeoutID = window.setTimeout(func, delay[, arg1, arg2, ...]);
|*|  var timeoutID = window.setTimeout(code, delay);
|*|  var intervalID = window.setInterval(func, delay[, arg1, arg2, ...]);
|*|  var intervalID = window.setInterval(code, delay);
|*|
\*/

(function() {
  setTimeout(function(arg1) {
    if (arg1 === 'test') {
      // feature test is passed, no need for polyfill
      return;
    }
    var __nativeST__ = window.setTimeout;
    window.setTimeout = function(vCallback, nDelay /*, argumentToPass1, argumentToPass2, etc. */ ) {
      var aArgs = Array.prototype.slice.call(arguments, 2);
      return __nativeST__(vCallback instanceof Function ? function() {
        vCallback.apply(null, aArgs);
      } : vCallback, nDelay);
    };
  }, 0, 'test');

  var interval = setInterval(function(arg1) {
    clearInterval(interval);
    if (arg1 === 'test') {
      // feature test is passed, no need for polyfill
      return;
    }
    var __nativeSI__ = window.setInterval;
    window.setInterval = function(vCallback, nDelay /*, argumentToPass1, argumentToPass2, etc. */ ) {
      var aArgs = Array.prototype.slice.call(arguments, 2);
      return __nativeSI__(vCallback instanceof Function ? function() {
        vCallback.apply(null, aArgs);
      } : vCallback, nDelay);
    };
  }, 0, 'test');
}())
</pre>

<h3 id="IE-only_fix">IE-only fix</h3>

<p>If you want a completely unobtrusive fix for every other mobile or desktop browser, including IE 9 and below, you can either use JavaScript conditional comments:</p>

<pre class="brush: js notranslate">/*@cc_on
  // conditional IE &lt; 9 only fix
  @if (@_jscript_version &lt;= 9)
  (function(f){
     window.setTimeout = f(window.setTimeout);
     window.setInterval = f(window.setInterval);
  })(function(f){return function(c,t){var a=[].slice.call(arguments,2);return f(function(){c instanceof Function?c.apply(this,a):eval(c)},t)}});
  @end
@*/
</pre>

<p>... or go for a very clean approach based on the IE HTML conditional feature:</p>

<pre class="brush: html notranslate">&lt;!--[if lte IE 9]&gt;&lt;script&gt;
(function(f){
window.setTimeout=f(window.setTimeout);
window.setInterval=f(window.setInterval);
})(function(f){return function(c,t){
var a=[].slice.call(arguments,2);return f(function(){c instanceof Function?c.apply(this,a):eval(c)},t)}
});
&lt;/script&gt;&lt;![endif]--&gt;
</pre>

<h3 id="Workarounds">Workarounds</h3>

<p>Another possibility is to use an anonymous function to call your callback, but this solution is a bit more expensive. Example:</p>

<pre class="brush: js notranslate">var intervalID = setTimeout(function() { myFunc('one', 'two', 'three'); }, 1000);
</pre>

<p>The above example can also be written with the help of an <a href="/en-US/docs/Web/JavaScript/Reference/Functions/Arrow_functions"> arrow function</a>:</p>

<pre class="brush: js notranslate">var intervalID = setTimeout(() =&gt; { myFunc('one', 'two', 'three'); }, 1000);
</pre>

<p>Yet another possibility is to use <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind">function's <code>bind</code></a>. Example:</p>

<pre class="brush: js notranslate">setTimeout(function(arg1){}.bind(undefined, 10), 1000);
</pre>

<h2 id="The_this_problem">The "this" problem</h2>

<p>When you pass a method to <code>setTimeout()</code> (or any other function, for that matter), it will be invoked with a <code>this</code> value that may differ from your expectation. This issue is explained in detail in the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this#As_an_object_method">JavaScript reference</a>.</p>

<h3 id="Explanation">Explanation</h3>

<p>Code executed by <code>setTimeout()</code> is called from an execution context separate from the function from which <code>setTimeout</code> was called. The usual rules for setting the <code>this</code> keyword for the called function apply, and if you have not set <code>this</code> in the call or with <code>bind</code>, it will default to the <code>window</code> (or <code>global</code>) object. It will not be the same as the <code>this</code> value for the function that called <code>setTimeout</code>.</p>

<p>See the following example:</p>

<pre class="brush: js notranslate">myArray = ['zero', 'one', 'two'];
myArray.myMethod = function (sProperty) {
  alert(arguments.length &gt; 0 ? this[sProperty] : this);
};

myArray.myMethod(); // prints "zero,one,two"
myArray.myMethod(1); // prints "one"</pre>

<p>The above works because when <code>myMethod</code> is called, its <code>this</code> is set to <code>myArray</code> by the call, so within the function, <code>this[sProperty]</code> is equivalent to <code>myArray[sProperty]</code>. However, in the following:</p>

<pre class="brush: js notranslate">setTimeout(myArray.myMethod, 1.0*1000); // prints "[object Window]" after 1 second
setTimeout(myArray.myMethod, 1.5*1000, '1'); // prints "undefined" after 1.5 seconds</pre>

<p>The <code>myArray.myMethod</code> function is passed to <code>setTimeout</code>, then when it's called, its <code>this</code> is not set so it defaults to the <code>window</code> object. There's also no option to pass a <code>thisArg</code> to setTimeout as there is in Array methods like forEach, reduce, etc. and as shown below, using <code>call</code> to set <code>this</code> doesn't work either.</p>

<pre class="brush: js notranslate">setTimeout.call(myArray, myArray.myMethod, 2.0*1000); // error: "NS_ERROR_XPC_BAD_OP_ON_WN_PROTO: Illegal operation on WrappedNative prototype object"
setTimeout.call(myArray, myArray.myMethod, 2.5*1000, 2); // same error
</pre>

<h3 id="Possible_solutions">Possible solutions</h3>

<p>A common way to solve the problem is to use a wrapper function that sets <code>this</code> to the required value:</p>

<pre class="brush: js notranslate">setTimeout(function(){myArray.myMethod()}, 2.0*1000); // prints "zero,one,two" after 2 seconds
setTimeout(function(){myArray.myMethod('1')}, 2.5*1000); // prints "one" after 2.5 seconds</pre>

<p>Arrow functions are a possible alternative, too:</p>

<pre class="brush: js notranslate">setTimeout(() =&gt; {myArray.myMethod()}, 2.0*1000); // prints "zero,one,two" after 2 seconds
setTimeout(() =&gt; {myArray.myMethod('1')}, 2.5*1000); // prints "one" after 2.5 seconds</pre>

<p>Another possible way to solve the "<code>this</code>" problem is to replace the host <code>setTimeout()</code> and <code>setInterval()</code> global functions with ones that allow passing a <code>this</code> object and set it in the callback using <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/call"><code>Function.prototype.call</code></a>, e.g.:</p>

<pre class="brush: js notranslate">// Enable setting 'this' in JavaScript timers

var __nativeST__ = window.setTimeout,
    __nativeSI__ = window.setInterval;

window.setTimeout = function (vCallback, nDelay /*, argumentToPass1, argumentToPass2, etc. */) {
  var oThis = this,
      aArgs = Array.prototype.slice.call(arguments, 2);
  return __nativeST__(vCallback instanceof Function ? function () {
    vCallback.apply(oThis, aArgs);
  } : vCallback, nDelay);
};

window.setInterval = function (vCallback, nDelay /*, argumentToPass1, argumentToPass2, etc. */) {
  var oThis = this,
      aArgs = Array.prototype.slice.call(arguments, 2);
  return __nativeSI__(vCallback instanceof Function ? function () {
    vCallback.apply(oThis, aArgs);
  } : vCallback, nDelay);
};</pre>

<div class="note"><strong>Note</strong>: These two replacements will also enable the HTML5 standard passage of arbitrary arguments to the callback functions of timers in IE. So they can be used as polyfills also. See the <a href="#Callback_arguments">Callback arguments</a> paragraph.</div>

<p>New feature test:</p>

<pre class="brush: js notranslate">myArray = ['zero', 'one', 'two'];
myArray.myMethod = function (sProperty) {
    alert(arguments.length &gt; 0 ? this[sProperty] : this);
};

setTimeout(alert, 1500, 'Hello world!'); // the standard use of setTimeout and setInterval is preserved, but...
setTimeout.call(myArray, myArray.myMethod, 2.0*1000); // prints "zero,one,two" after 2 seconds
setTimeout.call(myArray, myArray.myMethod, 2.5*1000, 2); // prints "two" after 2.5 seconds
</pre>

<div class="note"><strong>Note</strong>: JavaScript 1.8.5 introduced the <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind">Function.prototype.bind()</a></code> method to set the value of <code>this</code> for all calls to a given function. This can avoid having to use a wrapper function to set the value of <code>this</code> in a callback.</div>

<p>Example using <code>bind()</code>:</p>

<pre class="brush: js notranslate">myArray = ['zero', 'one', 'two'];
myBoundMethod = (function (sProperty) {
    console.log(arguments.length &gt; 0 ? this[sProperty] : this);
}).bind(myArray);

myBoundMethod(); // prints "zero,one,two" because 'this' is bound to myArray in the function
myBoundMethod(1); // prints "one"
setTimeout(myBoundMethod, 1.0*1000); // still prints "zero,one,two" after 1 second because of the binding
setTimeout(myBoundMethod, 1.5*1000, "1"); // prints "one" after 1.5 seconds
</pre>

<h2 id="Notes">Notes</h2>

<p>Timeouts are cancelled using {{domxref("WindowOrWorkerGlobalScope.clearTimeout()","clearTimeout()")}}.</p>

<p>To call a function repeatedly (e.g., every N milliseconds), consider using {{domxref("WindowOrWorkerGlobalScope.setInterval()","setInterval()")}}.</p>

<h3 id="Passing_string_literals">Passing string literals</h3>

<p>Passing a string instead of a function to <code>setTimeout()</code> has the same associated problems as using <code><a href="/en-US/docs/JavaScript/Reference/Global_Objects/eval#Don.27t_use_eval.21">eval</a>. </code></p>

<pre class="brush: js notranslate">// Recommended
window.setTimeout(function() {
  alert('Hello World!');
}, 500);

// Not recommended
window.setTimeout("alert('Hello World!');", 500);
</pre>

<p>A string passed to <code>setTimeout</code> is evaluated in the global context, so local symbols in the context where <code>setTimeout()</code> was called will not be available when the string is evaluated as code.</p>

<h3 id="Reasons_for_delays_longer_than_specified">Reasons for delays longer than specified</h3>

<p>There are a number of reasons why a timeout may take longer to fire than anticipated. This section describes the most common reasons.</p>

<h4 id="Timeouts_throttled_to_≥_4ms">Timeouts throttled to ≥ 4ms</h4>

<p>In modern browsers, <code>setTimeout()</code>/{{domxref("WindowOrworkerGlobalScope.setInterval","setInterval()")}} calls are throttled to a minimum of once every 4 ms when successive calls are triggered due to callback nesting (where the nesting level is at least a certain depth), or after certain number of successive intervals. Take this example:</p>

<pre class="brush: js notranslate">function cb() { setTimeout(cb, 0); }
function f() { setInterval(f, 0); }
setTimeout(cb, 0);
setInterval(f, 0);</pre>

<p>In Chrome and Firefox, the 5th successive callback call is clamped; Safari clamps on the 6th call; in Edge its the 3rd one. Gecko started to treat <code>setInterval()</code> like this in <a href="/en-US/docs/Mozilla/Firefox/Releases/56">version 56</a> (it already did this with <code>setTimeout()</code>; see below).</p>

<p><a class="external" href="http://code.google.com/p/chromium/issues/detail?id=792#c10">Historically</a> some browsers implemented this throttling behaviour a bit differently (e.g. Firefox) — on <code>setInterval()</code> calls made from anywhere, or when a nested <code>setTimeout()</code> is called where the nesting level is at least a certain depth.</p>

<p>To implement a 0 ms timeout in a modern browser, you can use {{domxref("window.postMessage()")}} as <a class="external" href="http://dbaron.org/log/20100309-faster-timeouts">described here</a>.</p>

<div class="note">
<p><strong>Note</strong>: The minimum delay, <code>DOM_MIN_TIMEOUT_VALUE</code>, is 4 ms (stored in a preference in Firefox: <code>dom.min_timeout_value</code>), with a <code>DOM_CLAMP_TIMEOUT_NESTING_LEVEL</code> of 5.</p>
</div>

<div class="note">
<p><strong>Note</strong>: 4 ms is <a class="external" href="http://www.whatwg.org/specs/web-apps/current-work/multipage/timers.html#timers">specified by the HTML5 spec</a> and is consistent across browsers released in 2010 and onward. Prior to {{geckoRelease("5.0")}}, the minimum timeout value for nested timeouts was 10 ms.</p>
</div>

<h4 id="Timeouts_in_inactive_tabs_throttled_to_≥_1000ms">Timeouts in inactive tabs throttled to ≥ 1000ms</h4>

<p>To reduce the load (and associated battery usage) from background tabs, timeouts are throttled to firing no more often than once per second (1,000 ms) in inactive tabs.</p>

<p>Firefox implements this behavior since version 5 (see {{bug(633421)}}, the 1000ms constant can be tweaked through the <span class="comment-copy"><code>dom.min_background_timeout_value</code> preference).</span> Chrome implements this behavior since version 11 (<a class="external" href="http://crbug.com/66078">crbug.com/66078</a>).</p>

<p>Firefox for Android uses a timeout value of 15 minutes for background tabs since {{bug(736602)}} in Firefox 14, and background tabs can also be unloaded entirely.</p>

<div class="note">
<p>Firefox 50 no longer throttles background tabs if a Web Audio API {{domxref("AudioContext")}} is actively playing sound. Firefox 51 further amends this such that background tabs are no longer throttled if an {{domxref("AudioContext")}} is present in the tab at all, even if no sound is being played. These resolve a number of issues with apps which play note-based music not being able to time or synchronize the music properly when the tab is in the background.</p>
</div>

<h4 id="Throttling_of_tracking_timeout_scripts">Throttling of tracking timeout scripts</h4>

<p>Since Firefox 55, tracking scripts (e.g. Google Analytics, any script URL that Firefox recognises as a tracking script through its <a href="https://wiki.mozilla.org/Security/Tracking_protection#Lists">TP lists</a>) have been subject to further throttling. When running in the foreground, the throttling minimum delay is still 4ms. In background tabs, however, the throttling minimum delay is 10,000 ms, or 10 seconds, which comes into effect 30 seconds after a document has first loaded.</p>

<p>The prefs that control this behaviour are:</p>

<ul>
 <li><code>dom.min_tracking_timeout_value</code>: 4</li>
 <li><code>dom.min_tracking_background_timeout_value</code>: 10000</li>
 <li><code>dom.timeout.tracking_throttling_delay</code>: 30000</li>
</ul>

<h4 id="Late_timeouts">Late timeouts</h4>

<p>In addition to "clamping", the timeout can also fire later when the page (or the OS/browser itself) is busy with other tasks. One important case to note is that the function or code snippet cannot be executed until the thread that called <code>setTimeout()</code> has terminated. For example:</p>

<pre class="brush: js notranslate">function foo() {
  console.log('foo has been called');
}
setTimeout(foo, 0);
console.log('After setTimeout');</pre>

<p>Will write to the console:</p>

<pre class="notranslate">After setTimeout
foo has been called</pre>

<p>This is because even though <code>setTimeout</code> was called with a delay of zero, it's placed on a queue and scheduled to run at the next opportunity; not immediately. Currently-executing code must complete before functions on the queue are executed, thus the resulting execution order may not be as expected.</p>

<h4 id="Deferral_of_timeouts_during_pageload">Deferral of timeouts during pageload</h4>

<p>Starting in Firefox 66, Firefox will defer firing setTimeout and setInterval timers while the current tab is loading.   Firing is deferred until the MainThread is deemed idle (similar to <a href="/en-US/docs/Web/API/Window/requestIdleCallback">window.requestIdleCallback()</a>), or until the load event is fired.</p>

<h3 id="WebExtension_background_pages_and_timers">WebExtension background pages and timers</h3>

<p>In <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions">WebExtension</a> background pages, timers don't work properly. This is because background pages don't actually stay loaded all the time: the browser can unload them if they are not being used, and restore them when they are needed. This is mostly transparent to the extension, but some things (including JS timers) won't work across an unload/restore cycle, so background pages are encouraged instead to use alarms, which will work. There's some more detail on this at <a href="https://developer.chrome.com/extensions/background_migration">Migrate to Event Driven Background Scripts</a>.</p>

<p>At the time of writing, only Chrome exhibited the above behaviour — Firefox doesn't yet do the unload/restore behavior, so timers will work. But it's still a good idea to avoid timers in WebExtensions, for a couple of reasons:</p>

<ol>
 <li>Compat with Chrome.</li>
 <li>Future changes in behavior that may cause problems.</li>
</ol>

<h3 id="Maximum_delay_value">Maximum delay value</h3>

<p>Browsers including Internet Explorer, Chrome, Safari, and Firefox store the delay as a 32-bit signed integer internally. This causes an integer overflow when using delays larger than 2,147,483,647 ms (about 24.8 days), resulting in the timeout being executed immediately.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webappapis.html#dom-settimeout', 'WindowOrWorkerGlobalScope.setTimeout()')}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Method moved to the <code>WindowOrWorkerGlobalScope</code> mixin in the latest spec.</td>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "webappapis.html#dom-settimeout", "WindowTimers.setTimeout()")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Initial definition (DOM Level 0)</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowOrWorkerGlobalScope.setTimeout")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/Add-ons/Code_snippets/Timers">JavaScript timers</a></li>
 <li><a href="/en-US/docs/Mozilla/JavaScript_code_modules/Timer.jsm">Timer.jsm</a></li>
 <li>{{domxref("WindowOrWorkerGlobalScope.clearTimeout")}}</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.setInterval")}}</li>
 <li>{{domxref("window.requestAnimationFrame")}}</li>
 <li><a href="/en-US/Add-ons/Code_snippets/Timers/Daemons"><em>Daemons</em> management</a></li>
</ul>
